import java.io.*;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
/**
 * @author Lim Long Hei Roy
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class TestClass extends JFrame implements ActionListener
    {

	private JMenuBar mBar;
	private JFrame mainFrame;
	private JFrame consoleFrame;
	private JMenu[] mainMenu = new JMenu[10];
	private JMenuItem[][] menuItem = new JMenuItem[10][10];
	private JTextArea tArea;

	public static void main(String[] args) {

	}

	public TestClass() {
		mBar = new JMenuBar();
		tArea = new JTextArea();
		mainFrame = new JFrame("COSMOS Simulation");
		mainMenu[0] = new JMenu("File");
		mainMenu[1] = new JMenu("Compilation");
		mainMenu[2] = new JMenu("Simulation");
		menuItem[0][0] = new JMenuItem("Load");
		menuItem[0][1] = new JMenuItem("Close");
		mainMenu[0].add(menuItem[0][0]);
		mainMenu[0].add(menuItem[0][1]);
		menuItem[1][0] = new JMenuItem("Compile");
		mainMenu[1].add(menuItem[1][0]);
		menuItem[2][0] = new JMenuItem("Simulate");
		mainMenu[2].add(menuItem[2][0]);
		mBar.add(mainMenu[0]);
		mBar.add(mainMenu[1]);
		mBar.add(mainMenu[2]);
		Container cp = mainFrame.getContentPane();
		cp.setLayout(new BorderLayout());
		cp.add(mBar, BorderLayout.NORTH);
		mainFrame.setSize(300, 100);
		mainFrame.setVisible(true);
		mainFrame.setLocation(700, 400);
		menuItem[0][0].addActionListener(this);
		menuItem[0][1].addActionListener(this);
		menuItem[1][0].addActionListener(this);
                
	}

        public void actionPerformed(ActionEvent e) {
		JMenuItem whichButton = (JMenuItem)e.getSource();
		if (whichButton.getText().equals("Load")) {
                         
                    MainWindow.tArea.append("start Loading...\n");
		} if (whichButton.getText().equals("Close")) {
			

                    MainWindow.tArea.append("closing...\n");
		} if (whichButton.getText().equals("Compile")) {
			Compile(); 
		    //tArea.append("start COSMOS simulator...\n");
		}
	}


	private void Compile() {
        //if (filePath == null)
        //{
        //    alert.setVisible(true);
        //    return;
        //}

	  try
        {
            File theFile = new File("Compile.exe");
            BufferedWriter fileWriter = new BufferedWriter(new FileWriter(theFile));
            fileWriter.write("#!/bin/sh\n");
            fileWriter.write("cd ../../../spice3f5\n");
            fileWriter.write("util/build sun4 gcc\n");
            fileWriter.flush();
            fileWriter.close();
        }
        catch (IOException ioe)
        {
           MainWindow.tArea.append("Cannot write the file due to error " + ioe.toString());
        }
        String theCmd0 = "chmod 777 Compile.exe";
        String theCmd = "./Compile.exe";
        MainWindow.tArea.append("util/build sun4 gcc\n");
	  try
        {
	    MainWindow.tArea.append("start compiling...\n");
	   Process theProcess0 = Runtime.getRuntime().exec(theCmd0);
            theProcess0.waitFor();
            Process theProcess = Runtime.getRuntime().exec(theCmd);
            //theProcess.waitFor();
            InputStream in = theProcess.getInputStream();
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            byte[] buffer = new byte[8192];
            int bytesRead = 0;
            while ((bytesRead = in.read(buffer, 0, 8192)) != -1) 
                baos.write(buffer, 0, bytesRead);
            String data = new String(baos.toByteArray());
            MainWindow.tArea.append(data);
	    MainWindow.tArea.append("compiled!\n");
        }
        catch (IOException ioe)
        {
            MainWindow.tArea.append("an I/O error occurs" + ioe.toString());
        }
        catch(InterruptedException e) 
        {
            MainWindow.tArea.append("Interrupted waiting for process!");
        }
	
	}
  }
